var agentOSVAD;
var isOSVADAgentVisible;


function removeAgent() {
    if (document.body.contains(agentOSVAD)) {
        document.body.removeChild(agentOSVAD);
    }
}

function setAgentSize(width, height) {
    var element = document.getElementsByTagName('body')[0];
    var style = window.getComputedStyle(element);
    var marginLeft = parseInt(style.marginLeft);
    var marginRight = parseInt(style.marginRight);

    var adjustedWidth = width - marginLeft - marginRight;
    console.log("marginLeft: " + marginLeft + ", marginRight: " + marginRight + ", adjustedWidth: " + adjustedWidth);

    agentOSVAD.style.width = adjustedWidth;
    agentOSVAD.style.height = height;
    //updateAgentBounds();
}

function updateAgentBounds() {
    if (agentOSVAD) {
        var rect = agentOSVAD.getBoundingClientRect();
        console.log(rect.top, rect.right, rect.bottom, rect.left);
        PokktOSVAD.updateAgentBounds(rect.left, rect.top, rect.right, rect.bottom);
    }
}

function setAgentBGColor(value) {
    if (agentOSVAD) {
        agentOSVAD.style.backgroundColor = value;
    }
}

function findLocationForAd() {
    setAgentBGColor("#FF00FF");
    //setAgentSize(30, 1); // initial
    updateAgentBounds();
}

function initPokktOSVAD() {
    // locate an element with id "osvad", it has to be of type "CENTER"
    agentOSVAD = document.getElementById("osvad");

    // if not found, create a new one and put it in the host page
    if (!agentOSVAD || agentOSVAD.nodeName != "CENTER") {
        agentOSVAD = document.createElement("center");
        agentOSVAD.id = "osvad";
        document.body.appendChild(agentOSVAD);
        console.log("element osvad is created!");
    } else {
        console.log("element osvad is already available!");
    }

    // this will also ensure the SDK that script is ready
    PokktOSVAD.pokktOSVADInitDone();
}


/**
 * helpers
 **/

function isElementInViewport(el) {
    var rect = el.getBoundingClientRect();
    return (
        rect.top >= 0 &&
        rect.left >= 0 &&
        rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) &&
        rect.right <= (window.innerWidth || document.documentElement.clientWidth)
    );
}

function updateVisibility() {
    if (agentOSVAD) {
        var newVisibility = isElementInViewport(agentOSVAD);
        if (newVisibility != isOSVADAgentVisible) {
            isOSVADAgentVisible = newVisibility;

            // visibility changed, notify
            PokktOSVAD.setAgentVisible(isOSVADAgentVisible);
        }
    }
}


/**
 * prepare handlers
 **/

var handler = function () {
    updateVisibility();
    if (agentOSVAD && isOSVADAgentVisible) {
        updateAgentBounds();
    }
}


/**
 * attach listeners
 **/

if (window.addEventListener) {
    addEventListener('scroll', handler, false);
    addEventListener('resize', handler, false);
} else if (window.attachEvent) {
    attachEvent('onscroll', handler);
    attachEvent('onresize', handler);
}


/**
 * init agent
 **/
initPokktOSVAD();
