package com.pokkt.demo

import android.app.Activity
import android.content.Context
import com.pokkt.PokktAds
import com.pokkt.igaservice.IGAServiceProvider
import com.pokkt.sdk.banners.PokktBannerView
import com.pokkt.sdk.models.PokktAdViewConfig
import com.pokkt.sdk.models.PokktUserDetails

fun setPokktConfig(applicationId: String, securityKey: String, activity: Activity) {
    PokktAds.setPokktConfig(applicationId, securityKey, activity)
}

fun setThirdPartyUserId(userId: String) {
    PokktAds.setThirdPartyUserId(userId)
}

fun setAdPlayerViewConfig(adPlayerViewConfig: PokktAdViewConfig) {
    PokktAds.setAdPlayerViewConfig(adPlayerViewConfig)
}

fun setUserDetails(userDetails: PokktUserDetails) {
    PokktAds.setUserDetails(userDetails)
}

fun setCallbackExtraParams(extraParams: Map<String, String>) {
    PokktAds.setCallbackExtraParams(extraParams)
}

fun setDataAccessConsent(consentInfo: PokktAds.ConsentInfo?) {
    if (consentInfo != null) {
        PokktAds.setDataAccessConsent(consentInfo)
    }
}

fun getDataAccessConsent(): PokktAds.ConsentInfo {
    return PokktAds.getDataAccessConsent()
}

fun getSDKVersion(): String {
    return PokktAds.getSDKVersion()
}

fun cacheAd(screenName: String, delegate: PokktAds.PokktAdDelegate?) {
    PokktAds.cacheAd(screenName,delegate)
}

fun showAd(screenName: String, delegate: PokktAds.PokktAdDelegate?, pokktBannerView: PokktBannerView?) {
    PokktAds.showAd(screenName,delegate,pokktBannerView)
}

fun isAdCached(screenName: String): Boolean {
    return PokktAds.isAdCached(screenName)
}

fun requestNativeAd(screenId: String, delegate: PokktAds.NativeAdsDelegate) {
    PokktAds.requestNativeAd(screenId, delegate)
}

fun destroy(container: PokktBannerView) {
    PokktAds.destroyBanner(container)
}

fun onRequestPermissionsResult(requestCode: Int, permissions: Array<String>, grantResults: IntArray, container: PokktBannerView) {
    PokktAds.onRequestPermissionsResult(requestCode, permissions, grantResults, container)
}

fun setIGAServiceProvider(igaServiceProvider: IGAServiceProvider) {
    PokktAds.InGameAd.setIGAServiceProvider(igaServiceProvider)
}

fun setDelegate(delegate: PokktAds.InGameAd.IGADelegate) {
    PokktAds.InGameAd.setDelegate(delegate)
}

fun fetchAssets(screenName: String) {
    PokktAds.InGameAd.fetchAssets(screenName)
}

fun trackFUClick(clickType: Int, assetType: String) {
    PokktAds.InGameAd.trackFUClick(clickType, assetType)
}

fun updateIGAData(data: String) {
    PokktAds.InGameAd.updateIGAData(data)
}

fun isEnabled(): Boolean {
    return PokktAds.Debugging.isEnabled()
}

fun shouldDebug(context: Context, value: Boolean) {
    PokktAds.Debugging.shouldDebug(context, value)
}

fun exportLog(context: Activity) {
    PokktAds.Debugging.exportLog(context)
}

fun exportLogToCloud(context: Context) {
    PokktAds.Debugging.exportLogToCloud(context)
}

fun showToast(context: Context, message: String) {
    PokktAds.Debugging.showToast(context, message)
}

fun showLog(message: String) {
    PokktAds.Debugging.showLog(message)
}