package com.pokkt.demo.fragments;

import android.os.Bundle;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import androidx.appcompat.widget.Toolbar;

import com.pokkt.PokktAds;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.PokktKotlinPluginKt;
import com.pokkt.demo.utility.SharedPrefsUtil;
import com.pokkt.demo.utility.SharedPrefsUtilConstant;
import com.pokkt.demo.utility.Storage;
import com.pokkt.sdk.models.PokktUserDetails;

import static com.pokkt.demo.utility.SharedPrefsUtilConstant.*;

public class PokktUserDetailsFragment extends BaseFragment {

    // ui
    // edt_security_key
    private EditText edtUserName, edtUserAge, edtUserSex, edtUserLocation, edtUserBirthday,
            edtUserFacebookId, edtUserTwitterHandle, edtUserEducationInfo, edtUserNationality,
            edtUserEmploymentStatus, edtUserEmailAddress, edtUserMaturityRating, edtUserMobileNumber,edtUserMaritalStatus;
    private Button btnClearData, btnSend;

    public PokktUserDetailsFragment() {
        // Required empty public constructor
    }


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        // getArguments here
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.fragment_pokkt_user_details, container, false);

        btnClearData = (Button) findView(rootView, R.id.btnClearData);
        btnSend = (Button) findView(rootView, R.id.btnSend);
        edtUserName = (EditText) findView(rootView, R.id.edtUserName);
        edtUserAge = (EditText) findView(rootView, R.id.edtUserAge);
        edtUserSex = (EditText) findView(rootView, R.id.edtUserSex);
        edtUserLocation = (EditText) findView(rootView, R.id.edtUserLocation);
        edtUserBirthday = (EditText) findView(rootView, R.id.edtUserBirthday);
        edtUserFacebookId = (EditText) findView(rootView, R.id.edtUserFacebookId);
        edtUserTwitterHandle = (EditText) findView(rootView, R.id.edtUserTwitterHandle);
        edtUserEducationInfo = (EditText) findView(rootView, R.id.edtUserEducationInfo);
        edtUserNationality = (EditText) findView(rootView, R.id.edtUserNationality);
        edtUserEmploymentStatus = (EditText) findView(rootView, R.id.edtUserEmploymentStatus);
        edtUserEmailAddress = (EditText) findView(rootView, R.id.edtUserEmailAddress);
        edtUserMaturityRating = (EditText) findView(rootView, R.id.edtUserMaturityRating);
        edtUserMobileNumber = (EditText) findView(rootView, R.id.edtUserMobileNumber);
        edtUserMaritalStatus = (EditText) findView(rootView, R.id.edtUserMaritalStatus);

        btnClearData.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                clearData();
            }
        });

        btnSend.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                saveData();
                if (hasDefaultValues()) {
                    Toast.makeText(getActivity().getApplicationContext(), "Add user info to be sent to PokktSDK", Toast.LENGTH_SHORT).show();
                } else {
                    PokktUserDetails pokktUserDetails = new PokktUserDetails();
                    pokktUserDetails.setName(edtUserName.getText().toString());
                    pokktUserDetails.setAge(edtUserAge.getText().toString());
                    pokktUserDetails.setSex(edtUserSex.getText().toString());
                    pokktUserDetails.setLocation(edtUserLocation.getText().toString());
                    pokktUserDetails.setBirthday(edtUserBirthday.getText().toString());
                    pokktUserDetails.setMaritalStatus(edtUserMaritalStatus.getText().toString());
                    pokktUserDetails.setFacebookId(edtUserFacebookId.getText().toString());
                    pokktUserDetails.setTwitterHandle(edtUserTwitterHandle.getText().toString());
                    pokktUserDetails.setEducationInformation(edtUserEducationInfo.getText().toString());
                    pokktUserDetails.setNationality(edtUserNationality.getText().toString());
                    pokktUserDetails.setEmploymentStatus(edtUserEmploymentStatus.getText().toString());
                    pokktUserDetails.setEmailAddress(edtUserEmailAddress.getText().toString());
                    pokktUserDetails.setMaturityRating(edtUserMaturityRating.getText().toString());
                    pokktUserDetails.setMobileNumber(edtUserMobileNumber.getText().toString());

                    if(Storage.isKotlin) {
                        PokktKotlinPluginKt.setUserDetails(pokktUserDetails);
                    } else {
                        PokktAds.setUserDetails(pokktUserDetails);
                    }
                }
            }
        });
        Toolbar toolbar = rootView.findViewById(R.id.pokkttoolbar);
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        return rootView;
    }

    @Override
    public void onViewCreated(View view, Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);

        setFont(findView(view, R.id.txt_ad_settings));
        setFont(findView(view, R.id.txtUserName));
        setFont(findView(view, R.id.txtUserAge));
        setFont(findView(view, R.id.txtUserSex));
        setFont(findView(view, R.id.txtUserLocation));
        setFont(findView(view, R.id.txtUserBirthday));
        setFont(findView(view, R.id.txtUserFacebookId));
        setFont(findView(view, R.id.txtUserTwitterHandle));
        setFont(findView(view, R.id.txtUserEducationInfo));
        setFont(findView(view, R.id.txtUserNationality));
        setFont(findView(view, R.id.txtUserEmploymentStatus));
        setFont(findView(view, R.id.txtUserEmailAddress));
        setFont(findView(view, R.id.txtUserMaturityRating));
        setFont(findView(view, R.id.txtUserMobileNumber));
        setFont(findView(view, R.id.txtUserMaritalStatus));

        setFont(edtUserName);
        setFont(edtUserName);
        setFont(edtUserAge);
        setFont(edtUserSex);
        setFont(edtUserLocation);
        setFont(edtUserBirthday);
        setFont(edtUserFacebookId);
        setFont(edtUserTwitterHandle);
        setFont(edtUserEducationInfo);
        setFont(edtUserNationality);
        setFont(edtUserEmploymentStatus);
        setFont(edtUserEmailAddress);
        setFont(edtUserMaturityRating);
        setFont(edtUserMobileNumber);
        setFont(edtUserMaritalStatus);

        try {
            bindData();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void bindData() throws Exception {
        if (SharedPrefsUtil.getMapFromPref(getActivity().getApplicationContext(), PREF_USER_DETAILS).size() > 0) {

            edtUserName.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_NAME));

            edtUserAge.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_AGE));

            edtUserSex.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_SEX));

            edtUserLocation.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_LOCATION));

            edtUserBirthday.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_BIRTHDAY));

            edtUserFacebookId.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_FACEBOOK_ID));

            edtUserTwitterHandle.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_TWITTER_HANDLE));

            edtUserEducationInfo.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_EDUCATION_INFO));

            edtUserNationality.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_NATIONALITY));

            edtUserEmploymentStatus.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_EMPLOYMENT_STATUS));

            edtUserEmailAddress.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_EMAIL_ADDRESS));

            edtUserMaturityRating.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_MATURITY_RATING));

            edtUserMobileNumber.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_MOBILE_NUMBER));
            edtUserMaritalStatus.setText(SharedPrefsUtil.getStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS, KEY_USER_MARITAL_STATUS));
        }
    }

    private void clearData() {

        edtUserName.setText("");
        edtUserAge.setText("");
        edtUserSex.setText("");
        edtUserLocation.setText("");
        edtUserBirthday.setText("");
        edtUserFacebookId.setText("");
        edtUserTwitterHandle.setText("");
        edtUserEducationInfo.setText("");
        edtUserNationality.setText("");
        edtUserEmploymentStatus.setText("");
        edtUserEmailAddress.setText("");
        edtUserMaturityRating.setText("");
        edtUserMobileNumber.setText("");
        edtUserMaritalStatus.setText("");
    }

    @Override
    public void onDestroy() {
        saveData();
        super.onDestroy();
    }

    private boolean hasDefaultValues() {
        return TextUtils.isEmpty(edtUserName.getText().toString()) &&
                TextUtils.isEmpty(edtUserAge.getText().toString()) &&
                TextUtils.isEmpty(edtUserSex.getText().toString()) &&
                TextUtils.isEmpty(edtUserLocation.getText().toString()) &&
                TextUtils.isEmpty(edtUserBirthday.getText().toString()) &&
                TextUtils.isEmpty(edtUserFacebookId.getText().toString()) &&
                TextUtils.isEmpty(edtUserTwitterHandle.getText().toString()) &&
                TextUtils.isEmpty(edtUserEducationInfo.getText().toString()) &&
                TextUtils.isEmpty(edtUserNationality.getText().toString()) &&
                TextUtils.isEmpty(edtUserEmploymentStatus.getText().toString()) &&
                TextUtils.isEmpty(edtUserEmailAddress.getText().toString()) &&
                TextUtils.isEmpty(edtUserMaturityRating.getText().toString()) &&
                TextUtils.isEmpty(edtUserMaritalStatus.getText().toString()) &&
                TextUtils.isEmpty(edtUserMobileNumber.getText().toString());
    }

    private void saveData() {
        SharedPrefsUtil.clearSharedPref(getActivity().getApplicationContext(), PREF_USER_DETAILS);
        if (!hasDefaultValues()) {
            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_NAME, edtUserName.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_AGE, edtUserAge.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    KEY_USER_SEX, edtUserSex.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_LOCATION, edtUserLocation.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_BIRTHDAY, edtUserBirthday.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_FACEBOOK_ID, edtUserFacebookId.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_TWITTER_HANDLE, edtUserTwitterHandle.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_EDUCATION_INFO, edtUserEducationInfo.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_NATIONALITY, edtUserNationality.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_EMPLOYMENT_STATUS, edtUserEmploymentStatus.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_EMAIL_ADDRESS, edtUserEmailAddress.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_MATURITY_RATING, edtUserMaturityRating.getText().toString());

            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_MOBILE_NUMBER, edtUserMobileNumber.getText().toString());
            SharedPrefsUtil.setStringPref(getActivity().getApplicationContext(),
                    PREF_USER_DETAILS,
                    SharedPrefsUtilConstant.KEY_USER_MARITAL_STATUS, edtUserMaritalStatus.getText().toString());
        }
    }
}
