package com.pokkt.demo.fragments.Wrapper;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.Toolbar;

import android.text.TextUtils;
import android.util.DisplayMetrics;
import android.util.Log;
import android.view.Display;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RatingBar;
import android.widget.TextView;
import android.widget.Toast;

import com.google.ads.consent.ConsentInformation;
import com.google.ads.consent.ConsentStatus;
import com.google.ads.mediation.admob.AdMobAdapter;
import com.google.android.gms.ads.AdListener;
import com.google.android.gms.ads.AdLoader;
import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdSize;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.ads.InterstitialAd;
import com.google.android.gms.ads.MobileAds;
import com.google.android.gms.ads.VideoController;
import com.google.android.gms.ads.VideoOptions;
import com.google.android.gms.ads.formats.MediaView;
import com.google.android.gms.ads.formats.NativeAdOptions;
import com.google.android.gms.ads.formats.UnifiedNativeAd;
import com.google.android.gms.ads.formats.UnifiedNativeAdView;
import com.google.android.gms.ads.reward.RewardItem;
import com.google.android.gms.ads.reward.RewardedVideoAd;
import com.google.android.gms.ads.reward.RewardedVideoAdListener;
import com.google.android.gms.ads.rewarded.RewardedAd;
import com.google.android.gms.ads.rewarded.RewardedAdCallback;
import com.google.android.gms.ads.rewarded.RewardedAdLoadCallback;
import com.pokkt.PokktAds;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.fragments.BaseFragment;
import com.pokkt.demo.fragments.Wrapper.admob.recyclerlist.AdMobNativeRecyclerActivity;

import java.util.Arrays;
import java.util.List;

public class AdMobFragment extends BaseFragment {
    private Button btnAdTypeVideo;
    private Button btnAdTypeInterstitial;
    private Button btnAdTypeBanner;
    private Button btnAdTypeNative;
    private Button btnAdTypeNativeList;

    private InterstitialAd mInterstitialAd;
    private AdLoader customEventNativeLoader;

//    private String testDeviceId = "9629CC110484A274A40F8C71220735AE,07D6977539005CFA70B403A3F13B9570";
    private String testDeviceId = "";
    private AdView bannerView;
    private LinearLayout bannerContainer = null;
    private ProgressBar progressShowInterstitial;
    private ProgressBar progressShowBanner;
    private ProgressBar progressShowNative;
    private String videoAdUnitId;
    private ProgressBar progressShowVideo;
    private String bannerAdUnitId;
    private View mainView;

    private UnifiedNativeAd nativeAd;

    public AdMobFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        mainView = inflater.inflate(R.layout.fragment_wrapper_admob, container, false);
        //video
        View videoView = mainView.findViewById(R.id.btn_ad_type_video);
        btnAdTypeVideo = (videoView.findViewById(R.id.button));
        btnAdTypeVideo.setText("Show Video");
        progressShowVideo = videoView.findViewById(R.id.progressBar);


        //interstitial
        View interView = mainView.findViewById(R.id.btn_ad_type_interstitial);
        btnAdTypeInterstitial = interView.findViewById(R.id.button);
        btnAdTypeInterstitial.setText("Show Interstitial");
        progressShowInterstitial = interView.findViewById(R.id.progressBar);

        //banner
        View bannerView = mainView.findViewById(R.id.btn_ad_type_banner);
        btnAdTypeBanner = bannerView.findViewById(R.id.button);
        btnAdTypeBanner.setText("Show Banner");
        progressShowBanner = bannerView.findViewById(R.id.progressBar);

        //Native Ad
        View nativeView = mainView.findViewById(R.id.btn_ad_type_native);
        btnAdTypeNative = nativeView.findViewById(R.id.button);
        btnAdTypeNative.setText("Show Native Ad");
        btnAdTypeNative.setContentDescription("test_admob_native");
        progressShowNative = nativeView.findViewById(R.id.progressBar);

        //Native Ad List
        View nativeViewList = mainView.findViewById(R.id.btn_ad_type_native_list);
        btnAdTypeNativeList = nativeViewList.findViewById(R.id.button);
        btnAdTypeNativeList.setContentDescription("test_admob_native_list");
        btnAdTypeNativeList.setText("Show Native Ad List");

        Toolbar toolbar = mainView.findViewById(R.id.pokkttoolbar);
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        toolbar.setTitle("AdMob");
        return mainView;

    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        bannerContainer = view.findViewById(R.id.admobbanner);

        //gdpr

        final CheckBox gdprApplicable = view.findViewById(R.id.gdprapplicable);
        final CheckBox gdprConsent = view.findViewById(R.id.gdprconsent);
        gdprApplicable.setChecked(PokktAds.getDataAccessConsent().isGDPRApplicable());
        gdprConsent.setChecked(PokktAds.getDataAccessConsent().isGDPRConsentAvailable());
        Button gdprConsentButton = view.findViewById(R.id.btn_gdpr);
        gdprConsentButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (gdprApplicable.isChecked()) {
                    if (gdprConsent.isChecked()) {
                        ConsentInformation.getInstance(getContext()).setConsentStatus(ConsentStatus.PERSONALIZED);
                    } else {
                        ConsentInformation.getInstance(getContext()).setConsentStatus(ConsentStatus.NON_PERSONALIZED);
                    }
                } else {
                    ConsentInformation.getInstance(getContext()).setConsentStatus(ConsentStatus.PERSONALIZED);
                }
            }
        });

        btnAdTypeInterstitial.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                {
                    //Init interstitial ad unit
                    String interstitialAdUnitId = ((EditText) (mainView.findViewById(R.id.edt_inter_adunitid))).getText().toString();
                    //interstitialAdUnitId = "ca-app-pub-9403393692924373/8834852042";
                    if (TextUtils.isEmpty(interstitialAdUnitId)) {
                        Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                        return;
                    }
                    mInterstitialAd = new InterstitialAd(getActivity());
                    mInterstitialAd.setAdUnitId(interstitialAdUnitId);

                    progressShowInterstitial.setVisibility(View.VISIBLE);
                    AdRequest.Builder requestBuilder = new AdRequest.Builder();
                    if (testDeviceId != null && testDeviceId.length() > 0) {
                        List<String> testDeviceIdList = Arrays.asList(testDeviceId.split(","));

                        for (String deviceId : testDeviceIdList) {
                            requestBuilder.addTestDevice(deviceId);
                        }
                    }
                    if (ConsentInformation.getInstance(getContext()).getConsentStatus() == ConsentStatus.NON_PERSONALIZED) {
                        Bundle extras = new Bundle();
                        extras.putString("npa", "1");
                        requestBuilder.addNetworkExtrasBundle(AdMobAdapter.class, extras);
                    } else {
                        Bundle extras = new Bundle();
                        extras.putString("npa", "0");
                        requestBuilder.addNetworkExtrasBundle(AdMobAdapter.class, extras);
                    }
                    AdRequest adRequest = requestBuilder.build();
                    mInterstitialAd.loadAd(adRequest);
                    mInterstitialAd.setAdListener(new AdListener() {
                        @Override
                        public void onAdClosed() {
                            super.onAdClosed();
                            PokktAds.Debugging.showToast(getActivity(), "Ad Closed");
                        }

                        @Override
                        public void onAdFailedToLoad(int i) {
                            super.onAdFailedToLoad(i);
                            Log.e("AdMobFragment", "Ad Load Failed " + i);
                            progressShowInterstitial.setVisibility(View.GONE);
                            PokktAds.Debugging.showToast(getActivity(), "Ad Failed to Load");
                        }

                        @Override
                        public void onAdLeftApplication() {
                            super.onAdLeftApplication();
                            PokktAds.Debugging.showToast(getActivity(), "Ad Left App");
                        }

                        @Override
                        public void onAdOpened() {
                            super.onAdOpened();
                            PokktAds.Debugging.showToast(getActivity(), "Ad Opened");
                        }

                        @Override
                        public void onAdLoaded() {
                            super.onAdLoaded();
                            mInterstitialAd.show();
                            progressShowInterstitial.setVisibility(View.GONE);
                            PokktAds.Debugging.showToast(getActivity(), "Ad Loaded");
                        }

                        @Override
                        public void onAdClicked() {
                            // Code to be executed when the user clicks on an ad.
                            PokktAds.Debugging.showToast(getActivity(), "Ad Clicked");
                        }
                    });
                }
            }
        });

        btnAdTypeVideo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                {
                    //Init video ad unit id
                    videoAdUnitId = ((EditText) (mainView.findViewById(R.id.edt_video_adunitid))).getText().toString();
                    //videoAdUnitId = "ca-app-pub-9403393692924373/4404652445";
                    if (TextUtils.isEmpty(videoAdUnitId)) {
                        Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                        return;
                    }
                    progressShowVideo.setVisibility(View.VISIBLE);
                    AdRequest.Builder requestBuilder = new AdRequest.Builder();
                    if (testDeviceId != null && testDeviceId.length() > 0) {
                        List<String> testDeviceIdList = Arrays.asList(testDeviceId.split(","));

                        for (String deviceId : testDeviceIdList) {
                            requestBuilder.addTestDevice(deviceId);
                        }
                    }
                    final RewardedAd videoAd = new RewardedAd(getActivity(), videoAdUnitId);
                    if (ConsentInformation.getInstance(getContext()).getConsentStatus() == ConsentStatus.NON_PERSONALIZED) {
                        Bundle extras = new Bundle();
                        extras.putString("npa", "1");
                        requestBuilder.addNetworkExtrasBundle(AdMobAdapter.class, extras);
                    } else {
                        Bundle extras = new Bundle();
                        extras.putString("npa", "0");
                        requestBuilder.addNetworkExtrasBundle(AdMobAdapter.class, extras);
                    }
                    AdRequest adRequest = requestBuilder.build();
                    //zarnaa was doing like this and was getting fail show advertisement.
//                    if(! videoAd.isLoaded() ) {
//                        videoAd.loadAd(videoAdUnitId, adRequest);
//                        if(! mInterstitialAd.isLoaded() ) {
//                            mInterstitialAd.loadAd(adRequest);
//                        } else{
//                            mInterstitialAd.show();
//                        }
//                    } else {
//                        videoAd.show();
//                    }
                    final RewardedAdCallback rewardedAdCallback = new RewardedAdCallback() {
                        @Override
                        public void onUserEarnedReward(com.google.android.gms.ads.rewarded.RewardItem rewardItem) {
                            Toast.makeText(getActivity(), rewardItem.getAmount() + " " + rewardItem.getType() + " Earned", Toast.LENGTH_SHORT).show();
                        }

                        @Override
                        public void onRewardedAdOpened() {
                            PokktAds.Debugging.showToast(getActivity(), "Video Opened");
                        }

                        @Override
                        public void onRewardedAdClosed() {
                            PokktAds.Debugging.showToast(getActivity(), "Video Closed");
                        }
                    };
                    RewardedAdLoadCallback rewardedAdLoadCallback = new RewardedAdLoadCallback() {
                        @Override
                        public void onRewardedAdLoaded() {
                            videoAd.show(getActivity(), rewardedAdCallback);
                            progressShowVideo.setVisibility(View.GONE);
                            PokktAds.Debugging.showToast(getActivity(), "Video Loaded");
                        }

                        @Override
                        public void onRewardedAdFailedToLoad(int i) {
                            Log.e("AdMobFragment", "Ad Load Failed " + i);
                            progressShowVideo.setVisibility(View.GONE);
                            PokktAds.Debugging.showToast(getActivity(), "Video Failed To Load");
                        }
                    };
                    videoAd.loadAd(adRequest,rewardedAdLoadCallback);
                }
            }
        });

        //show banner
        btnAdTypeBanner.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                //Init banner ad unit id
                bannerAdUnitId = ((EditText) (mainView.findViewById(R.id.edt_banner_adunitid))).getText().toString();
                //bannerAdUnitId = "ca-app-pub-9403393692924373/3838929242";
                if (TextUtils.isEmpty(bannerAdUnitId)) {
                    Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (bannerView != null) {
                    bannerView.destroy();
                }
//                bannerView = mainView.findViewById(R.id.bannerId);
                bannerView = new AdView(getActivity());
                bannerView.setAdUnitId(bannerAdUnitId);
                AdSize size = getBannerSize(bannerContainer);
                bannerView.setAdSize(size);
//                AdSize size = getAdaptiveBannerAdSize();
//                bannerView.setAdSize(size);
//                bannerView.setAdSize(AdSize.SMART_BANNER);
                if (bannerContainer.getChildCount() > 0) {
                    bannerContainer.removeAllViews();
                }
                bannerContainer.addView(bannerView);

                progressShowBanner.setVisibility(View.VISIBLE);
                bannerView.setAdListener(new AdListener() {
                    @Override
                    public void onAdClosed() {
                        super.onAdClosed();
                    }

                    @Override
                    public void onAdLoaded() {
                        super.onAdLoaded();
                        Log.d("AdMob", "Ad Loaded");
                        progressShowBanner.setVisibility(View.GONE);
                        PokktAds.Debugging.showToast(getActivity(), "Banner Loaded");
                    }

                    @Override
                    public void onAdOpened() {
                        super.onAdOpened();
                    }

                    @Override
                    public void onAdLeftApplication() {
                        super.onAdLeftApplication();
                        bannerView.destroy();
                        bannerView = null;
                    }

                    @Override
                    public void onAdFailedToLoad(int i) {
                        super.onAdFailedToLoad(i);
                        Log.d("AdMob", "Ad Failed " + i);
                        progressShowBanner.setVisibility(View.GONE);
                        PokktAds.Debugging.showToast(getActivity(), "Banner Load Failed");
                    }
                });


                AdRequest adRequest = null;
                AdRequest.Builder requestBuilder = new AdRequest.Builder();
                if (testDeviceId != null && testDeviceId.length() > 0) {
                    List<String> testDeviceIdList = Arrays.asList(testDeviceId.split(","));

                    for (String deviceId : testDeviceIdList) {
                        requestBuilder.addTestDevice(deviceId);
                    }
                }
                if (ConsentInformation.getInstance(getContext()).getConsentStatus() == ConsentStatus.NON_PERSONALIZED) {
                    Bundle extras = new Bundle();
                    extras.putString("npa", "1");
                    requestBuilder.addNetworkExtrasBundle(AdMobAdapter.class, extras);
                } else {
                    Bundle extras = new Bundle();
                    extras.putString("npa", "0");
                    requestBuilder.addNetworkExtrasBundle(AdMobAdapter.class, extras);
                }
                adRequest = requestBuilder.build();
                bannerView.loadAd(adRequest);
            }
        });

        //show NativeAd
        btnAdTypeNative.setOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View v) {
                //Init banner ad unit id
                EditText adUnitEditText = ((EditText) (mainView.findViewById(R.id.edt_native_adunitid)));
                String nativeAdUnitId = adUnitEditText.getText().toString();
                //nativeAdUnitId = "ca-app-pub-9403393692924373/7555898498";
                adUnitEditText.setContentDescription("test_native_edt_adunit");
                if (TextUtils.isEmpty(nativeAdUnitId)) {
                    Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                    return;
                }
                progressShowNative.setVisibility(View.VISIBLE);
                createCustomEventNativeLoader(nativeAdUnitId);

                AdRequest adRequest = null;
                AdRequest.Builder requestBuilder = new AdRequest.Builder();
                if (testDeviceId != null && testDeviceId.length() > 0) {
                    List<String> testDeviceIdList = Arrays.asList(testDeviceId.split(","));

                    for (String deviceId : testDeviceIdList) {
                        requestBuilder.addTestDevice(deviceId);
                    }
                }
                if (ConsentInformation.getInstance(getContext()).getConsentStatus() == ConsentStatus.NON_PERSONALIZED) {
                    Bundle extras = new Bundle();
                    extras.putString("npa", "1");
                    requestBuilder.addNetworkExtrasBundle(AdMobAdapter.class, extras);
                } else {
                    Bundle extras = new Bundle();
                    extras.putString("npa", "0");
                    requestBuilder.addNetworkExtrasBundle(AdMobAdapter.class, extras);
                }
                adRequest = requestBuilder.build();
                customEventNativeLoader.loadAd(adRequest);
            }
        });

        btnAdTypeNativeList.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Init banner ad unit id
                EditText adUnitEditText = ((EditText) (mainView.findViewById(R.id.edt_native_adunitid)));
                String nativeAdUnitId = adUnitEditText.getText().toString();
                //nativeAdUnitId = "ca-app-pub-9403393692924373/7555898498";
                adUnitEditText.setContentDescription("test_native_edt_adunit");
                if (TextUtils.isEmpty(nativeAdUnitId)) {
                    Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent i = new Intent(getActivity(), AdMobNativeRecyclerActivity.class);
                i.putExtra("AdUnit",nativeAdUnitId);
                startActivity(i);
            }
        });
    }

    private void createCustomEventNativeLoader(String nativeAdUnitId) {
        /**
         * Sample Custom Event Native ad.
         */
        VideoOptions videoOptions = new VideoOptions.Builder()
                .setStartMuted(true)
                .build();

        NativeAdOptions adOptions = new NativeAdOptions.Builder()
                .setVideoOptions(videoOptions)
                .build();
        customEventNativeLoader = new AdLoader.Builder(getActivity(), nativeAdUnitId)
                .forUnifiedNativeAd(new UnifiedNativeAd.OnUnifiedNativeAdLoadedListener() {
                    @Override
                    public void onUnifiedNativeAdLoaded(UnifiedNativeAd unifiedNativeAd) {
                        progressShowNative.setVisibility(View.GONE);
                        LayoutInflater inflater = (LayoutInflater) getContext().getSystemService( Context.LAYOUT_INFLATER_SERVICE );
                        FrameLayout frameLayout = (FrameLayout) mainView.findViewById(R.id.customeventnative_framelayout);
                        UnifiedNativeAdView adView = (UnifiedNativeAdView) inflater.inflate(R.layout.admob_ad_unified, null);
                        populateUnifiedNativeAdView(unifiedNativeAd, adView);
                        frameLayout.removeAllViews();
                        frameLayout.addView(adView);
                        nativeAd = unifiedNativeAd;
                    }
                })
                .withAdListener(new AdListener() {
                    @Override
                    public void onAdFailedToLoad(int errorCode) {
                        progressShowNative.setVisibility(View.GONE);
                        Toast.makeText(getActivity(), "Custom event native ad failed with code: " + errorCode, Toast.LENGTH_SHORT).show();
                    }
                })
                .withNativeAdOptions(adOptions).build();
    }

    private void populateUnifiedNativeAdView(UnifiedNativeAd nativeAd, UnifiedNativeAdView adView) {
        // Set the media view. Media content will be automatically populated in the media view once
        // adView.setNativeAd() is called.
        MediaView mediaView = adView.findViewById(R.id.ad_media);
        adView.setMediaView(mediaView);
        adView.getMediaView().setMediaContent(nativeAd.getMediaContent());

        // Set other ad assets.
        adView.setHeadlineView(adView.findViewById(R.id.ad_headline));
        adView.setBodyView(adView.findViewById(R.id.ad_body));
        adView.setCallToActionView(adView.findViewById(R.id.ad_call_to_action));
        adView.setIconView(adView.findViewById(R.id.ad_app_icon));
        adView.setPriceView(adView.findViewById(R.id.ad_price));
        adView.setStarRatingView(adView.findViewById(R.id.ad_stars));
        adView.setStoreView(adView.findViewById(R.id.ad_store));
        adView.setAdvertiserView(adView.findViewById(R.id.ad_advertiser));

        // The headline is guaranteed to be in every UnifiedNativeAd.
        ((TextView) adView.getHeadlineView()).setText(nativeAd.getHeadline());

        // These assets aren't guaranteed to be in every UnifiedNativeAd, so it's important to
        // check before trying to display them.
        if (nativeAd.getBody() == null) {
            adView.getBodyView().setVisibility(View.INVISIBLE);
        } else {
            adView.getBodyView().setVisibility(View.VISIBLE);
            ((TextView) adView.getBodyView()).setText(nativeAd.getBody());
        }

        if (nativeAd.getCallToAction() == null) {
            adView.getCallToActionView().setVisibility(View.INVISIBLE);
        } else {
            adView.getCallToActionView().setVisibility(View.VISIBLE);
            ((Button) adView.getCallToActionView()).setText(nativeAd.getCallToAction());
        }

        if (nativeAd.getIcon() == null) {
            adView.getIconView().setVisibility(View.GONE);
        } else {
            ((ImageView) adView.getIconView()).setImageDrawable(
                    nativeAd.getIcon().getDrawable());
            adView.getIconView().setVisibility(View.VISIBLE);
        }

        if (nativeAd.getPrice() == null) {
            adView.getPriceView().setVisibility(View.INVISIBLE);
        } else {
            adView.getPriceView().setVisibility(View.VISIBLE);
            ((TextView) adView.getPriceView()).setText(nativeAd.getPrice());
        }

        if (nativeAd.getStore() == null) {
            adView.getStoreView().setVisibility(View.INVISIBLE);
        } else {
            adView.getStoreView().setVisibility(View.VISIBLE);
            ((TextView) adView.getStoreView()).setText(nativeAd.getStore());
        }

        if (nativeAd.getStarRating() == null || nativeAd.getStarRating() < 3) {
            adView.getStarRatingView().setVisibility(View.INVISIBLE);
        } else {
            ((RatingBar) adView.getStarRatingView())
                    .setRating(nativeAd.getStarRating().floatValue());
            adView.getStarRatingView().setVisibility(View.VISIBLE);
        }

        if (nativeAd.getAdvertiser() == null) {
            adView.getAdvertiserView().setVisibility(View.INVISIBLE);
        } else {
            ((TextView) adView.getAdvertiserView()).setText(nativeAd.getAdvertiser());
            adView.getAdvertiserView().setVisibility(View.VISIBLE);
        }

        // This method tells the Google Mobile Ads SDK that you have finished populating your
        // native ad view with this native ad. The SDK will populate the adView's MediaView
        // with the media content from this native ad.
        adView.setNativeAd(nativeAd);
        // Get the video controller for the ad. One will always be provided, even if the ad doesn't
        // have a video asset.
        VideoController vc = nativeAd.getVideoController();

        // Updates the UI to say whether or not this ad has a video asset.
        if (vc.hasVideoContent()) {
            //videoStatus.setText(String.format(Locale.getDefault(), "Video status: Ad contains a %.2f:1 video asset.", vc.getAspectRatio()));

            // Create a new VideoLifecycleCallbacks object and pass it to the VideoController. The
            // VideoController will call methods on this object when events occur in the video
            // lifecycle.
            vc.setVideoLifecycleCallbacks(new VideoController.VideoLifecycleCallbacks() {
                @Override
                public void onVideoEnd() {
                    // Publishers should allow native ads to complete video playback before
                    // refreshing or replacing them with another ad in the same UI location.
                    //refresh.setEnabled(true);
                    //videoStatus.setText("Video status: Video playback has ended.");
                    super.onVideoEnd();
                }
            });
        } else {
            //videoStatus.setText("Video status: Ad does not contain a video asset.");
            //refresh.setEnabled(true);
        }
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
    }

    @Override
    public void onDetach() {
        super.onDetach();
        if (bannerView != null) {
            bannerView.destroy();
        }
        if(nativeAd != null) {
            nativeAd.destroy();
        }
    }

    private AdSize getAdaptiveBannerAdSize() {
        Display display = getActivity().getWindowManager().getDefaultDisplay();
        DisplayMetrics outMetrics = new DisplayMetrics();
        display.getMetrics(outMetrics);

        float widthPixels = outMetrics.widthPixels;
        float density = outMetrics.density;

        int adWidth = (int) (widthPixels / density);
        return AdSize.getCurrentOrientationAnchoredAdaptiveBannerAdSize(getContext(), adWidth);
    }

    private AdSize getBannerSize(View view) {
        int height = view.getHeight();
        int width = view.getWidth();
        if (height >= AdSize.BANNER.getHeight() && width >= AdSize.BANNER.getWidth())
            return AdSize.BANNER;
        if (height >= AdSize.FULL_BANNER.getHeight() && width >= AdSize.FULL_BANNER.getWidth())
            return AdSize.FULL_BANNER;
        if (height >= AdSize.LARGE_BANNER.getHeight() && width >= AdSize.LARGE_BANNER.getWidth())
            return AdSize.LARGE_BANNER;
        if (height >= AdSize.LEADERBOARD.getHeight() && width >= AdSize.LEADERBOARD.getWidth())
            return AdSize.LEADERBOARD;
        if (height >= AdSize.MEDIUM_RECTANGLE.getHeight() && width >= AdSize.MEDIUM_RECTANGLE.getWidth())
            return AdSize.MEDIUM_RECTANGLE;
        if (height >= AdSize.WIDE_SKYSCRAPER.getHeight() && width >= AdSize.WIDE_SKYSCRAPER.getWidth())
            return AdSize.WIDE_SKYSCRAPER;
        return AdSize.SMART_BANNER;
    }
}
