package com.pokkt.demo.fragments.Wrapper;

import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.appcompat.widget.Toolbar;

import android.text.TextUtils;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.Toast;

import com.mopub.common.MoPub;
import com.mopub.common.MoPubReward;
import com.mopub.common.SdkConfiguration;
import com.mopub.common.logging.MoPubLog;
import com.mopub.common.privacy.PersonalInfoManager;
import com.mopub.mobileads.MoPubErrorCode;
import com.mopub.mobileads.MoPubInterstitial;
import com.mopub.mobileads.MoPubRewardedVideoListener;
import com.mopub.mobileads.MoPubRewardedVideos;
import com.mopub.mobileads.MoPubView;
import com.mopub.mobileads.PokktMoPubCustomEventNative;
import com.mopub.nativeads.AdapterHelper;
import com.mopub.nativeads.MediaViewBinder;
import com.mopub.nativeads.MoPubNative;
import com.mopub.nativeads.MoPubVideoNativeAdRenderer;
import com.mopub.nativeads.NativeAd;
import com.mopub.nativeads.NativeErrorCode;
import com.mopub.nativeads.ViewBinder;
import com.pokkt.PokktAds;
import com.pokkt.ad.demo.R;
import com.pokkt.demo.activities.MainActivity;
import com.pokkt.demo.fragments.BaseFragment;
import com.pokkt.demo.fragments.Wrapper.nativead.recyclerlist.MoPubNativeRecyclerActivity;

import java.util.Set;

public class MoPubFragment extends BaseFragment implements MoPubRewardedVideoListener, MoPubView.BannerAdListener {
    private Button btnAdTypeVideo;
    private Button btnAdTypeInterstitial;
    private Button btnAdTypeBanner;
    private Button btnAdTypeNative;
    private Button btnAdTypeNativeList;

    private MoPubInterstitial mInterstitialAd;
    private MoPubView bannerView;
    private LinearLayout bannerContainer = null;
    private ProgressBar progressShowInterstitial;
    private ProgressBar progressShowNative;
    private ProgressBar progressShowBanner;
    private String videoAdUnitId = "";
    private ProgressBar progressShowVideo;
    private String bannerAdUnitId = "";
    private View mainView;
    private MoPubNative moPubNative;

    public MoPubFragment() {
        // Required empty public constructor
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        mainView = inflater.inflate(R.layout.fragment_wrapper_admob, container, false);
        //video
        View videoView = mainView.findViewById(R.id.btn_ad_type_video);
        btnAdTypeVideo = (videoView.findViewById(R.id.button));
        btnAdTypeVideo.setText("Show Video");
        progressShowVideo = videoView.findViewById(R.id.progressBar);


        //interstitial
        View interView = mainView.findViewById(R.id.btn_ad_type_interstitial);
        btnAdTypeInterstitial = interView.findViewById(R.id.button);
        btnAdTypeInterstitial.setText("Show Interstitial");
        progressShowInterstitial = interView.findViewById(R.id.progressBar);

        //Native Video
        View nativeView = mainView.findViewById(R.id.btn_ad_type_native);
        btnAdTypeNative = nativeView.findViewById(R.id.button);
        btnAdTypeNative.setText("Show Native");
        btnAdTypeNative.setContentDescription("test_mopub_native");
        progressShowNative = nativeView.findViewById(R.id.progressBar);

        //Native Ad List
        View nativeViewList = mainView.findViewById(R.id.btn_ad_type_native_list);
        btnAdTypeNativeList = nativeViewList.findViewById(R.id.button);
        btnAdTypeNativeList.setContentDescription("test_mopub_native_list");
        btnAdTypeNativeList.setText("Show Native Ad List");

        //banner
        View bannerView = mainView.findViewById(R.id.btn_ad_type_banner);
        btnAdTypeBanner = bannerView.findViewById(R.id.button);
        btnAdTypeBanner.setText("Show Banner");
        progressShowBanner = bannerView.findViewById(R.id.progressBar);
        MoPub.initializeSdk(getActivity(), new SdkConfiguration.Builder("7d37a34a95f84bc292f7ec235f25d31d").build(), null);

        Toolbar toolbar = mainView.findViewById(R.id.pokkttoolbar);
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        toolbar.setTitle("MoPub");
        return mainView;

    }

    @Override
    public void onViewCreated(View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        bannerContainer = view.findViewById(R.id.admobbanner);

        //gdpr
        final CheckBox gdprApplicable = view.findViewById(R.id.gdprapplicable);
        final CheckBox gdprConsent = view.findViewById(R.id.gdprconsent);
        gdprApplicable.setChecked(PokktAds.getDataAccessConsent().isGDPRApplicable());
        gdprConsent.setChecked(PokktAds.getDataAccessConsent().isGDPRConsentAvailable());
        Button gdprConsentButton = view.findViewById(R.id.btn_gdpr);
        gdprConsentButton.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                PersonalInfoManager mPersonalInfoManager = MoPub.getPersonalInformationManager();
                if (mPersonalInfoManager != null) {
                    if (gdprApplicable.isChecked()) {
                        if (gdprConsent.isChecked()) {
                            mPersonalInfoManager.grantConsent();
                        } else {
                            mPersonalInfoManager.revokeConsent();
                        }
                    } else {
                        mPersonalInfoManager.grantConsent();
                    }
                }
            }
        });

        btnAdTypeInterstitial.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                {
                    //Init interstitial ad unit
                    String interstitialAdUnitId = ((EditText) (mainView.findViewById(R.id.edt_inter_adunitid))).getText().toString();

                    if (TextUtils.isEmpty(interstitialAdUnitId)) {
                        Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                        return;
                    }
                    if (!MoPub.isSdkInitialized()) {
                        SdkConfiguration.Builder configurationBuilder = new SdkConfiguration.Builder(interstitialAdUnitId);
                        configurationBuilder.withLogLevel(MoPubLog.LogLevel.DEBUG);
                        MoPub.initializeSdk(getActivity(), configurationBuilder.build(), null);
                    }
                    mInterstitialAd = new MoPubInterstitial(getActivity(), interstitialAdUnitId);
                    progressShowInterstitial.setVisibility(View.VISIBLE);
                    mInterstitialAd.setInterstitialAdListener(new MoPubInterstitial.InterstitialAdListener() {

                        @Override
                        public void onInterstitialLoaded(MoPubInterstitial interstitial) {
                            mInterstitialAd.show();
                            progressShowInterstitial.setVisibility(View.GONE);
                            PokktAds.Debugging.showToast(getActivity(), "Ad Displayed");
                        }

                        @Override
                        public void onInterstitialFailed(MoPubInterstitial interstitial, MoPubErrorCode errorCode) {
                            Log.e("MoPub", "Interstitial Load Failed " + errorCode);
                            progressShowInterstitial.setVisibility(View.GONE);
                            PokktAds.Debugging.showToast(getActivity(), "Ad failed to load: " + errorCode);
                        }

                        @Override
                        public void onInterstitialShown(MoPubInterstitial interstitial) {
                            PokktAds.Debugging.showToast(getActivity(), "Ad Displayed");
                        }

                        @Override
                        public void onInterstitialClicked(MoPubInterstitial interstitial) {
                            PokktAds.Debugging.showToast(getActivity(), "Ad Clicked");
                        }

                        @Override
                        public void onInterstitialDismissed(MoPubInterstitial interstitial) {
                            PokktAds.Debugging.showToast(getActivity(), "Ad Closed");
                        }
                    });
                    mInterstitialAd.load();
                }
            }
        });

        btnAdTypeVideo.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                //Init video ad unit id
                videoAdUnitId = ((EditText) (mainView.findViewById(R.id.edt_video_adunitid))).getText().toString();
                if (TextUtils.isEmpty(videoAdUnitId)) {
                    Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                    return;
                }
                progressShowVideo.setVisibility(View.VISIBLE);
                if (!MoPub.isSdkInitialized()) {
                    SdkConfiguration.Builder configurationBuilder = new SdkConfiguration.Builder(videoAdUnitId);
                    configurationBuilder.withLogLevel(MoPubLog.LogLevel.DEBUG);
                    MoPub.initializeSdk(getActivity(), configurationBuilder.build(), null);
                }
                MoPubRewardedVideos.setRewardedVideoListener(MoPubFragment.this);
                MoPubRewardedVideos.loadRewardedVideo(videoAdUnitId);
            }
        });

        //show banner
        btnAdTypeBanner.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                //Init banner ad unit id
                bannerAdUnitId = ((EditText) (mainView.findViewById(R.id.edt_banner_adunitid))).getText().toString();
                if (TextUtils.isEmpty(bannerAdUnitId)) {
                    Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (!MoPub.isSdkInitialized()) {
                    SdkConfiguration.Builder configurationBuilder = new SdkConfiguration.Builder(bannerAdUnitId);
                    configurationBuilder.withLogLevel(MoPubLog.LogLevel.DEBUG);
                    MoPub.initializeSdk(getActivity(), configurationBuilder.build(), null);
                }
                if (bannerView != null) {
                    bannerView.destroy();
                }

                bannerView = new MoPubView(getActivity());
                bannerView.setAdUnitId(bannerAdUnitId);
                bannerContainer.setVisibility(View.VISIBLE);
                if (bannerContainer.getChildCount() > 0) {
                    bannerContainer.removeAllViews();
                }
                bannerContainer.addView(bannerView);
                progressShowBanner.setVisibility(View.VISIBLE);
                bannerView.setBannerAdListener(MoPubFragment.this);

                bannerView.loadAd();
            }
        });

        //show native video
        btnAdTypeNative.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Init native ad unit
                EditText adUnitEditText = ((EditText) (mainView.findViewById(R.id.edt_native_adunitid)));
                String nativeAdUnitId = adUnitEditText.getText().toString();
                adUnitEditText.setContentDescription("test_native_edt_adunit");

                final FrameLayout parentView = mainView.findViewById(R.id.customeventnative_framelayout);

                if (TextUtils.isEmpty(nativeAdUnitId)) {
                    Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (!MoPub.isSdkInitialized()) {
                    SdkConfiguration.Builder configurationBuilder = new SdkConfiguration.Builder(nativeAdUnitId);
                    configurationBuilder.withLogLevel(MoPubLog.LogLevel.DEBUG);
                    MoPub.initializeSdk(getActivity(), configurationBuilder.build(), null);
                }
                final AdapterHelper adapterHelper = new AdapterHelper(getActivity(), 0, 3); // When standalone, any range will be fine.

                MoPubNative.MoPubNativeNetworkListener moPubNativeNetworkListener = new MoPubNative.MoPubNativeNetworkListener() {
                    @Override
                    public void onNativeLoad(NativeAd nativeAd) {
                        progressShowNative.setVisibility(View.GONE);
                        PokktAds.Debugging.showToast(getActivity(), "Ad Displayed");
                        NativeAd.MoPubNativeEventListener listener = new NativeAd.MoPubNativeEventListener() {
                            @Override
                            public void onImpression(View view) {

                            }

                            @Override
                            public void onClick(View view) {

                            }
                        };
                        // Retrieve the pre-built ad view that AdapterHelper prepared for us.
                        View v = adapterHelper.getAdView(null, parentView, nativeAd, new ViewBinder.Builder(0).build());
                        // Set the native event listeners (onImpression, and onClick).
                        nativeAd.setMoPubNativeEventListener(listener);
                        // Add the ad view to our view hierarchy
                        parentView.addView(v);

                    }

                    @Override
                    public void onNativeFail(NativeErrorCode errorCode) {
                        progressShowNative.setVisibility(View.GONE);
                        PokktAds.Debugging.showToast(getActivity(), "Ad failed to load: " + errorCode);


                    }
                };

//                MoPubNative moPubNative = new MoPubNative(getActivity(), "11a17b188668469fb0412708c3d16813 ", moPubNativeNetworkListener);
//                MoPubNative moPubNative = new MoPubNative(getActivity(), "02a2d288d2674ad09f3241d46a44356e ", moPubNativeNetworkListener);
                moPubNative = new MoPubNative(getActivity(), nativeAdUnitId, moPubNativeNetworkListener);

                MediaViewBinder mediaViewBinder = new MediaViewBinder.Builder(R.layout.mopub_native_ad_layout)
                        .mediaLayoutId(R.id.native_ad_media_layout)
                        .iconImageId(R.id.native_ad_icon_image)
                        .titleId(R.id.native_ad_title)
                        .textId(R.id.native_ad_text)
                        .build();
                MoPubVideoNativeAdRenderer moPubVideoNativeAdRenderer = new MoPubVideoNativeAdRenderer(mediaViewBinder);
                moPubNative.registerAdRenderer(moPubVideoNativeAdRenderer);

                progressShowNative.setVisibility(View.VISIBLE);

                moPubNative.makeRequest();
            }
        });

        btnAdTypeNativeList.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Init banner ad unit id
                EditText adUnitEditText = ((EditText) (mainView.findViewById(R.id.edt_native_adunitid)));
                String nativeAdUnitId = adUnitEditText.getText().toString();
                adUnitEditText.setContentDescription("test_native_edt_adunit");
                if (TextUtils.isEmpty(nativeAdUnitId)) {
                    Toast.makeText(getActivity(), "Invalid Ad Unit", Toast.LENGTH_SHORT).show();
                    return;
                }
                Intent i = new Intent(getActivity(), MoPubNativeRecyclerActivity.class);
                i.putExtra("AdUnit",nativeAdUnitId);
                startActivity(i);
            }
        });
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
//        if (context instanceof OnFragmentInteractionListener) {
//            mListener = (OnFragmentInteractionListener) context;
//        }
//        else {
//            throw new RuntimeException(context.toString()
//                    + " must implement OnFragmentInteractionListener");
//        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        if(moPubNative != null) {
            moPubNative.destroy();
            PokktMoPubCustomEventNative.destroyAd();
        }
        if (bannerView != null) {
            bannerView.destroy();
        }
    }

    @Override
    public void onRewardedVideoLoadSuccess(@NonNull String adUnitId) {
        Log.e("MoPub", "Rewarded Video loaded");
        if (MoPubRewardedVideos.hasRewardedVideo(adUnitId)) {
            MoPubRewardedVideos.showRewardedVideo(adUnitId);
        } else {
            Log.e("MoPub", "Rewarded Video not available");
        }
        PokktAds.Debugging.showToast(getActivity(), "Ad Loaded");
        progressShowVideo.setVisibility(View.GONE);
    }

    @Override
    public void onRewardedVideoLoadFailure(@NonNull String adUnitId, @NonNull MoPubErrorCode errorCode) {
        Log.e("MoPub", "Video Load Failed " + errorCode);
        PokktAds.Debugging.showToast(getActivity(), "Ad failed to load: " + errorCode);
        progressShowVideo.setVisibility(View.GONE);
    }

    @Override
    public void onRewardedVideoStarted(@NonNull String adUnitId) {
        PokktAds.Debugging.showToast(getActivity(), "Ad Displayed");
    }

    @Override
    public void onRewardedVideoPlaybackError(@NonNull String adUnitId, @NonNull MoPubErrorCode errorCode) {
        PokktAds.Debugging.showToast(getActivity(), "Ad Play Error");
    }

    @Override
    public void onRewardedVideoClicked(@NonNull String adUnitId) {
        PokktAds.Debugging.showToast(getActivity(), "Ad Clicked");
    }

    @Override
    public void onRewardedVideoClosed(@NonNull String adUnitId) {
        PokktAds.Debugging.showToast(getActivity(), "Ad Closed");
    }

    @Override
    public void onRewardedVideoCompleted(@NonNull Set<String> adUnitIds, @NonNull MoPubReward reward) {
        PokktAds.Debugging.showToast(getActivity(), "Reward Earned : " + reward.getAmount());

    }

    @Override
    public void onBannerLoaded(MoPubView banner) {
        Log.d("MoPub", "Ad Loaded");
        progressShowBanner.setVisibility(View.GONE);
        PokktAds.Debugging.showToast(getActivity(), "Banner Loaded");
    }

    @Override
    public void onBannerFailed(MoPubView banner, MoPubErrorCode errorCode) {
        Log.d("MoPub", "Banner Ad Failed " + errorCode);
        progressShowBanner.setVisibility(View.GONE);
        PokktAds.Debugging.showToast(getActivity(), "Banner Load Failed :" + errorCode);
    }

    @Override
    public void onBannerClicked(MoPubView banner) {
        PokktAds.Debugging.showToast(getActivity(), "Banner Clicked");
    }

    @Override
    public void onBannerExpanded(MoPubView banner) {
        PokktAds.Debugging.showToast(getActivity(), "Banner expanded");
    }

    @Override
    public void onBannerCollapsed(MoPubView banner) {
        PokktAds.Debugging.showToast(getActivity(), "Banner Closed");
    }
}
