package com.pokkt.demo.fragments.Wrapper;

import android.content.Context;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.appcompat.widget.Toolbar;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;

import com.pokkt.ad.demo.R;
import com.pokkt.demo.fragments.BaseFragment;
import com.pokkt.demo.fragments.PokktUserDetailsFragment;
import com.pokkt.demo.utility.FragmentTransactionManager;

public class PokktWrapperFragment extends BaseFragment implements OnWrapperSelectListener {

    public PokktWrapperFragment() {
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_wrapper_list, container, false);
        RecyclerView recyclerView = view.findViewById(R.id.list);
        // Set the adapter
        Context context = view.getContext();
        recyclerView.setLayoutManager(new LinearLayoutManager(context));
        recyclerView.setAdapter(new WrapperRecyclerViewAdapter(NetworkDetails.ITEMS, this));
        Toolbar toolbar = view.findViewById(R.id.pokkttoolbar);
        toolbar.setNavigationOnClickListener(new View.OnClickListener(){
            @Override
            public void onClick(View view) {
                getActivity().onBackPressed();
            }
        });
        return view;
    }

    @Override
    public void onWrapperSelected(NetworkDetails.NetworkItem item) {
        switch (item.id) {
            case 1:
                AdMobFragment adMobFragment = new AdMobFragment();
                FragmentTransactionManager.addFragmentWithTag(getActivity(), R.id.container, adMobFragment, PokktUserDetailsFragment.class.getSimpleName());
                break;
            case 2:
                MoPubFragment moPubFragment = new MoPubFragment();
                FragmentTransactionManager.addFragmentWithTag(getActivity(), R.id.container, moPubFragment, PokktUserDetailsFragment.class.getSimpleName());
                break;
        }
    }
}