package com.pokkt.demo.fragments.Wrapper;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;

import androidx.recyclerview.widget.RecyclerView;

import com.pokkt.ad.demo.R;
import com.pokkt.demo.fragments.Wrapper.NetworkDetails.NetworkItem;
import java.util.List;

public class WrapperRecyclerViewAdapter extends RecyclerView.Adapter<WrapperRecyclerViewAdapter.ViewHolder> {

    private final List<NetworkItem> mValues;
    private final OnWrapperSelectListener mListener;

    public WrapperRecyclerViewAdapter(List<NetworkItem> items, OnWrapperSelectListener listener) {
        mValues = items;
        mListener = listener;
    }

    @Override
    public ViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        View view = LayoutInflater.from(parent.getContext()).inflate(R.layout.fragment_wrapper_item, parent, false);
        return new ViewHolder(view);
    }

    @Override
    public void onBindViewHolder(final ViewHolder holder, int position) {
        holder.mItem = mValues.get(position);
        holder.mContentView.setText(mValues.get(position).content);

        holder.mContentView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if (null != mListener) {
                    mListener.onWrapperSelected(holder.mItem);
                }
            }
        });
    }

    @Override
    public int getItemCount() {
        return mValues.size();
    }

    class ViewHolder extends RecyclerView.ViewHolder {
        final View mView;
        final Button mContentView;
        NetworkItem mItem;

        ViewHolder(View view) {
            super(view);
            mView = view;
            mContentView = (Button) view.findViewById(R.id.content);
        }

        @Override
        public String toString() {
            return super.toString() + " '" + mContentView.getText() + "'";
        }
    }
}
