package com.pokkt.demo.fragments.Wrapper.nativead.recyclerlist;

import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.TextView;

import androidx.annotation.NonNull;
import androidx.recyclerview.widget.RecyclerView;

import com.pokkt.ad.demo.R;
import com.pokkt.demo.fragments.Wrapper.admob.recyclerlist.ListItem;

import java.util.List;

class MoPubNativeRecyclerViewAdapter extends RecyclerView.Adapter<RecyclerView.ViewHolder> {

    private final List<Object> mRecyclerViewItems;

    MoPubNativeRecyclerViewAdapter(List<Object> recyclerViewItems) {
        this.mRecyclerViewItems = recyclerViewItems;
    }

    public class ItemViewHolder extends RecyclerView.ViewHolder {
        private TextView itemName;
        private TextView itemDescription;

        ItemViewHolder(View view) {
            super(view);
            itemName = view.findViewById(R.id.item_name);
            itemDescription = view.findViewById(R.id.item_description);
        }
    }

    @Override
    public int getItemCount() {
        return mRecyclerViewItems.size();
    }

    @Override
    public int getItemViewType(int position) {
        return 0;
    }

    @NonNull
    @Override
    public RecyclerView.ViewHolder onCreateViewHolder(@NonNull ViewGroup viewGroup, int viewType) {
        View itemLayoutView = LayoutInflater.from(viewGroup.getContext()).inflate(R.layout.native_list_item, viewGroup, false);
        return new ItemViewHolder(itemLayoutView);
    }

    @Override
    public void onBindViewHolder(@NonNull RecyclerView.ViewHolder holder, int position) {
        ItemViewHolder itemHolder = (ItemViewHolder) holder;
        ListItem item = (ListItem) mRecyclerViewItems.get(position);

        // Add the menu item details to the menu item view.
        itemHolder.itemName.setText(item.getName());
        itemHolder.itemDescription.setText(item.getDescription());
    }
}